#include "frepla2.h"
#include "lcdbseta.c"



#byte puerto_a=0x05
#byte puerto_b=0x06
#byte TRISA=0x85
#byte TRISB=0x86
#byte TMR0=1
#byte OPTION_REG=0x81
#byte INTE=0x0B
#byte STATUS=3


#byte T1CON=0x10
#byte TMR1L=0x0E
#byte TMR1H=0x0F
#byte PIR1=0x0C


unsigned char numero;
unsigned char numero2;
unsigned char numero3;
unsigned char aretardo;
unsigned char aretardo2;

char VARI[16];


// Se pone para que no modifique el ensamblador
#OPT 0

void frecu9a()
{

#ASM
      BsF     puerto_b     , 07   //Enciende LED
      Bcf   T1CON,0               // pone a cero TMR1ON Desactiva contador
      clrf  TMR1L
      clrf  TMR1H
      clrf  numero3
      BCF     PIR1,0             //Borra rebase
      Bsf   T1CON,0              // pone a uno TMR1ON activa contador
      
      //______________________________
BUCLEX03:               ;   Total 20uS
//        nop                 ;   1      
                      //______TOTAL BUCLE 19 uS______
        movf   PIR1,0       ;   1   1        //9  CICLOS 9uS
        ANDLW   0x01        ;   1   1   
        btfsc 3,2   ;       ;   1   2   
        GOTO    SALTO13     ;   2   0   
        MOVLW   0x01        ;   0   1       //incrementa numero3
        ADDWF   numero3,f   ;   0   1       
        BCF     PIR1,0      ;   0   1       //Borra rebase
        GOTO    SALTO23     ;   0   2         
SALTO13: 
        NOP                 ;   1   0   
        NOP                 ;   1   0   
        NOP                 ;   1   0
        NOP                 ;   1   0     //_______________
SALTO23:  
        MOVLW   0x01          ;   1   1
        SUBWF   aretardo, f   ;   1   1
        btfsc  3,0   ;skpnc   ;   1   2
        GOTO    SAL13         ;   2   0
        DECF    aretardo2, f  ;   0   1    //___10 ciclos___
SAL13:     
      MOVF    aretardo,W   ;      1   1
      ADDWF   aretardo2,W   ;     1   1
      btfsc 3,2   ;skpnz     ;    2   1
      btfsc 3,0   ;SKPNC     ;    1   2    //_______________
      GOTO    BUCLEX03       ;    2   0
SALIR23:    
      //______________________________
      Bcf   T1CON,0               // pone a cero TMR1ON Desactiva contador
      movf  TMR1L,w
      MOVWF   numero
      movf  TMR1H,w
      MOVWF   numero2
      BcF     puerto_b     , 07   //Apaga LED
#ENDASM
}

void main()
{
 unsigned int z;
 float xx;
 unsigned char escala,multipli;
 
     puerto_b=0;
     puerto_a=0;
   
//Puerto B como salida, el RB6 entrada de frecuencia
     TRISB=0x40;
//Puerto A como entrada 
     TRISA=0xff;
        
      lcd_ini_seta();   
      lcd_cls();         
      lcd_gotoxy(1,1);
      Lcd_putc("xsetaseta@gmail");
      delay_seta(60000);
      lcd_cls();
      Lcd_putc ("   SETA43  ");
      delay_seta(60000);
      delay_seta(60000);

      T1CON=0b00000111;
      escala=2;
 
 while(true)
 {  
      if(bit_test(puerto_a,4)==1)
         {
            escala++;
            if(escala>2)escala=0;
            lcd_cls();
            lcd_gotoxy(1,1);
            Lcd_putc ("Cambiando escala ");
            while(bit_test(puerto_a,4)==1);
            lcd_cls();
         }
      lcd_gotoxy(1,1);   
      switch(escala)
             {
               case 0:
//                  Lcd_putc ("Escala0");
                  Lcd_putc ("0-16MHz  1S      ");
                  aretardo=0x50;
                  aretardo2=0xc3;

                  T1CON=0b00000111;
                  multipli=1;
                  break;
               case 1:
//                Lcd_putc ("Escala1");
                  Lcd_putc ("0-16MHz  0.1S    ");                  
                  aretardo=0x88;
                  aretardo2=0x13;
                  T1CON=0b00000111;
                  multipli=10;
                  break;
               case 2:
//                Lcd_putc ("Escala2");
                  Lcd_putc ("0-65MHZ  0.4S  ");
                  aretardo=0x20;
                  aretardo2=0x4E;
                  T1CON=0b00100111;    //dividido por 4
                  multipli=10;
                  break;             
            }             
      
      lcd_gotoxy(16,1);
      lcd_putc("*");
      delay_seta(10000);
      frecu9a();
      lcd_gotoxy(16,1);
      lcd_putc(" ");
      
      xx=(numero+numero2*256+numero3*65536)*multipli;
      lcd_gotoxy(0,2);     

      sprintf(VARI,"%9.0f",xx);
      for(z=0;z<9;z++)
       {
         if(z==3 || z==6)lcd_putc(".");
         if(VARI[z]<58 && VARI[z]>47 )
            lcd_putc(VARI[z]);
            else
            lcd_putc("0");      
       }
      lcd_putc(" Hz ");

      lcd_gotoxy(18,1);      
      delay_seta(10000);     
 }
  
}
